#include "resource.h"

#include <stdio.h>
#include "Main.h"
#include "WCH55xISPDLL.h"
#pragma comment(lib,"WCH55xISPDLL")
#include <time.h>

extern HWND AfxMainHwnd;
extern CH55xIspOptionS AfxIspOption;  //ѡǰ
extern BOOL AfxAutoDnAfterPlug;  //豸Զ


//ǰISPѡ
BOOL CH56x_SetIspOption()
{
	CHAR TemBuf[64] = "";
	CHAR FileName[MAX_PATH] = "";	
	CH55xIspOptionS IspOption = {0};
	BOOL RetVal = FALSE;

	//豸
	IspOption.IspMcuType = (CH55X_TYPE)SendDlgItemMessage(AfxMainHwnd,IDC_ChipType,CB_GETCURSEL,0,0);
	//ؽӿ
	IspOption.IspInterface = SendDlgItemMessage(AfxMainHwnd,IDC_DnInterface,CB_GETCURSEL,0,0);
	//ɺǷλֱĿ
	IspOption.IsMcuResetAfterIsp = (IsDlgButtonChecked(AfxMainHwnd,IDC_ResetAfterIsp) == BST_CHECKED);  		
	//ʹϵ縴λڼĶʱλ
	IspOption.IsEnableLongRest = (IsDlgButtonChecked(AfxMainHwnd,IDC_LONG_RESET) == BST_CHECKED);    
	
	//ָֹλ,CH554ʹRST,ͺָP5.7
	IspOption.IsEnableResetPin = (IsDlgButtonChecked(AfxMainHwnd,IDC_P5_RESET) == BST_CHECKED);;
	
	//þǿ,CH554֧
	IspOption.IsXtOscStrong = (IsDlgButtonChecked(AfxMainHwnd,IDC_OSC_STRONG) == BST_CHECKED);        
	//ʹϵͳλڼP0˿ڵڲ,CH554֧
	IspOption.IsEnableP0PullUp = (IsDlgButtonChecked(AfxMainHwnd,IDC_P0_PULLUP) == BST_CHECKED);;    
	//ϵIAP
	//IspOption.IsFirstRunIAP = (IsDlgButtonChecked(AfxMainHwnd,IDC_CHECK_RUN_IAP) == BST_CHECKED);
	//IspOption.IsEnableIAP = (IsDlgButtonChecked(AfxMainHwnd,IDC_CHECK_START_IAP) == BST_CHECKED);
	//ǷIAP
	IspOption.IsEnableIAP = (IsDlgButtonChecked(AfxMainHwnd,IDC_CHECK_START_IAP) == BST_CHECKED);
	//IAPʼַ
	GetDlgItemText(AfxMainHwnd,IDC_EDIT_IAP_ADDR,TemBuf,sizeof(TemBuf));
	IspOption.IAPStartAddr = mStrToHEX(TemBuf);
	//IAPļ
	GetDlgItemText(AfxMainHwnd,IDC_IapDnFile,IspOption.IapFileName,sizeof(IspOption.IapFileName));	
	
	//ûļ
	GetDlgItemText(AfxMainHwnd,IDC_UserDnFile,IspOption.UserFileName,sizeof(IspOption.UserFileName));	

	//豸֪ͨ
	IspOption.IsEnableUsbPnpNotify = (IsDlgButtonChecked(AfxMainHwnd,IDC_EnableUsbPnpNotify) == BST_CHECKED); 

	IspOption.BootPinNum = (IsDlgButtonChecked(AfxMainHwnd,IDC_BootP1) == BST_CHECKED); ;
	IspOption.IsNoKeyDnAtSer = (IsDlgButtonChecked(AfxMainHwnd,IDC_AutoIspNoKeySel) == BST_CHECKED);

	IspOption.IsClearDataFlash = (IsDlgButtonChecked(AfxMainHwnd,IDC_IsClearDataFlash) == BST_CHECKED);
	
	//ϵIAP,CH554֧
	if( IspOption.IspMcuType <= MCU_CH554 )
	{
		//þǿ,CH554֧
		IspOption.IsXtOscStrong = FALSE; 
		//ʹϵͳλڼP0˿ڵڲ,CH554֧
		IspOption.IsEnableP0PullUp = FALSE;    

		IspOption.IsFirstRunIAP = FALSE;
		IspOption.IsEnableIAP = FALSE;		
	}

	if( IspOption.IspInterface == 1 ) //ز֧²
	{
		IspOption.IsEnableUsbPnpNotify = FALSE; //
	}
	
	if( IspOption.IsEnableUsbPnpNotify )//豸֪ͦͨ
	{
		//IspOption.UsbPnpNotifyRoutine = CH55X_USB_NOTIFY_ROUTINE; //豸ʱô˺
	}
	else
	{			
		IspOption.UsbPnpNotifyRoutine = NULL; //ȡ豸μ
	}	

	if( WCH55x_SetIspOption(&IspOption) ) //isp	
	{
		memcpy(&AfxIspOption,&IspOption,sizeof(IspOption));
		RetVal = TRUE;
	}
	else
	{
		ZeroMemory(&AfxIspOption,sizeof(AfxIspOption));
	}
	AfxAutoDnAfterPlug = (IsDlgButtonChecked(AfxMainHwnd,IDC_AutoDnAfterPlug) == BST_CHECKED); //豸ǷԶ

	return RetVal;

}