// 2016.12
//****************************************
//**  Copyright  (C)  WCH  2002-2016    **
//**  Web:  http://WCH.CN               **
//****************************************
//**  DLL for WCH MCU ISP               **
//**  C, VC6.0                          **
//****************************************
//
// WCH MCU ISP API  V1.0
// ߺɷ޹˾  : TECH30 2016.12
// л: Windows Windows 2000 and later
// support chip: CH55X
//

#ifndef		_WCH55XISP_DLL_H
#define		_WCH55XISP_DLL_H

#ifdef __cplusplus
extern "C" {
#endif


#define		mOFFSET( s, m )			( (ULONG) & ( ( ( s * ) 0 ) -> m ) )	// ȡṹԱƫƵַĺ

#ifndef		max
#define		max( a, b )				( ( ( a ) > ( b ) ) ? ( a ) : ( b ) )	// ϴֵ
#endif

#ifndef		min
#define		min( a, b )				( ( ( a ) < ( b ) ) ? ( a ) : ( b ) )	// Сֵ
#endif

#define MAX_ISPDEV_NUM 16 

//MCU
#define   MCU_CH55X   0
#define   MCU_CH56X   1
#define   MCU_CH54X   2
#define   MCU_CH57X   3
#define   MCU_CH32F1X 4
#define   MCU_CH32V1X 5
#define   MCU_CH58X   6 
#define   MCU_CH32V3X 7 
#define   MCU_CH32F2X 8 

typedef		VOID	( CALLBACK	* mPCH55X_USB_NOTIFY_ROUTINE ) (  // 豸¼֪ͨص
		    ULONG			iEventStatus,  // 豸¼͵ǰ״̬(ж): 0=豸γ¼, 3=豸¼
			ULONG           DevIndexArray, //Ƴ豸
			ULONG           DevCnt);       //ǰ豸

#define InforType_Succ 0
#define InforType_Err  1
#define InforType_Hit  2
typedef		VOID	( CALLBACK	* mOutputPrint ) (  // ӦòϢ
												  UCHAR InforType,WCHAR *DataStr);


typedef		VOID	( CALLBACK	* mAppendPrint ) (  // ӦòϢ׷
			ULONG LineNo,WCHAR *DataStr);

typedef		VOID	( CALLBACK	* mPCH55X_USB_NOTIFY_ROUTINE ) (  // 豸¼֪ͨص
		    ULONG			iEventStatus,  // 豸¼͵ǰ״̬(ж): 0=豸γ¼, 3=豸¼
			ULONG           DevIndexArray, //Ƴ豸
			ULONG           DevCnt);       //ǰ豸



#pragma pack(1) //ǿƽ#pragma pack(1) ...#pragma pack֮ĽṹΪ1ֽڶ,scsiҪ8ֽڶ(Ĭ8ֽ).

typedef struct _CHIP_INFOEX {
	TCHAR		ChipName[16];
	UINT		FlashMaxSize;
	UINT		EepromMaxSize;
	BOOL		IsNetworkDownloadAvailable;
	BOOL		IsUsbDownloadAvailable;
	BOOL		IsSerialDownloadAvailable;
	UCHAR   	DeviceType;
	LIST_ENTRY	listEntry;
	UCHAR		ChipId;
	USHORT		EepromStartAddr;
	TCHAR       Introduction[256];
	TCHAR       IntroductionEn[256];
}CHIP_INFOEX, *PCHIP_INFOEX;

//ISP豸ṹϢ
typedef struct _ISP55XDEVICEINFOR
{
	ULONG       Index;         //öٺ豸
	UCHAR       McuType;       //0:MCU_CH56X, 1:MCU_CH56X,ext
	BOOL        IsSupportUID;  //MCUǷֻ֧ȡUID,汾֧UIDȡ
	UCHAR       IspVer[4];     //ISP汾
	UCHAR       IspMcuUID[8];  //MCUΨһID
	CHAR        PortName[32];  //豸ֻдʱֵ
	BOOL        DevIsOnline;   //豸Ƿϸôڣֻڴʱ
	BOOL        IsCoolBoot; //ǷϵBOOTǣ޸λ
	UCHAR       MacAddr[6];
	BOOL        IsPreBTV230;
}Isp55xDevInforS,*PIsp55xDevInforS;


//ISP豸
typedef struct _CH55xISPSETTING
{
	ULONG       IspInterface;  //ؽӿ 0:USB1:	 2:
	UCHAR       IspMcuType;    //оƬͺ,оƬͺŵλCH563д0x63
	UCHAR       IspMcuSeries;  //оƬϵ 0:CH55X;1:CH56X
	
	BOOL   IsEnableLongRest;    //ʹϵ縴λڼĶʱλ
	BOOL   IsXtOscStrong;       //þǿ,CH554֧
	BOOL   IsEnableResetPin;    //ָֹλ,CH554ʹRST,ͺָP5.7
	BOOL   IsEnableP0PullUp;    //ʹϵͳλڼP0˿ڵڲ,CH554֧
	BOOL   IsMcuResetAfterIsp;  //ɺǷλֱĿ(ֻ֧ģʽ)
	BOOL   IsEnableCfgBuf64K;
	BOOL   EnableIce;
	BOOL   EnableBootLoader;
	BOOL   IsSetNetDevMac;
	UCHAR  NetDevMacAddr[6];    //CH58Xʱһֽ¼д
	BOOL   IsCodeProtect;       //ô뱣
	BOOL   IsFirstRunIAP;       //ϵIAP
	BOOL   IsEnableIAP;         //ǷIAP
	ULONG  IAPStartAddr;        //IAPʼַ
	CHAR   UserFileName[MAX_PATH]; //ûļ
	CHAR   IapFileName[MAX_PATH];  //IAPļ	
	CHAR   DataFileName[MAX_PATH]; //Dataflashļ

	BOOL   IsNoKeyDnAtSer;       //棬識
	UCHAR  BootPinNum;           //ISPý
	BOOL   IsClearDataFlash;     //DataFlash

	BOOL   IsEnableUsbPnpNotify; //ǷUSB֪ͨ
	BOOL   IsEraseAllCFlash;
	BOOL   IsEraseAllDFlash;
	mPCH55X_USB_NOTIFY_ROUTINE   UsbPnpNotifyRoutine;     //֪ͨص

	ULONG  LocalIP;              //ISP IPַ
	ULONG  GatewayIP;
	ULONG  MaskIP;
	BOOL   IsSetDevIP;
	ULONG  dwDevIP;

	mOutputPrint AppOutput;       //ӦóϢӡ
	mAppendPrint AppAppendOutput; //ӦóϢ׷Ӵӡ

	BOOL    UILangIsCH;           //Ӣ
	UCHAR   LV_RST_VOL;           //޵ѹ
	BOOL    IsSimulat;            //߷Խӿʹ
	BOOL    IsBootLoader;         //ʹ
	BOOL    IsPorCtr;
	BOOL    IsUsbdPu;
	BOOL	IsUsbdMode;
	BOOL	IsStandbyRst;
	BOOL	IsStopRst;
	BOOL	IsIwdgSw;
	UCHAR   WPR_DATA[8];

	BOOL    IsEnLockup;
	BOOL    IsEnOutReset;
	BOOL    IsEnDebug;
	UCHAR   UserMem;
	UCHAR   Baud[4];
}CH55xIspOptionS,*PCH55xIspOptionS;


#pragma pack() 

#define		CH375_DEVICE_ARRIVAL		3		// 豸¼,Ѿ
#define		CH375_DEVICE_REMOVE			0		// 豸γ¼,Ѿγ


//CH55X ISP

/*
USBؿʵֲԶغһζ豸
USBʹò:
1.ISP,ؽӿڣоƬͺţвǰ
  WCH55x_SetIspOption,ISP
  ҪڲʱԶأǰ:CH55xIspOptionS->IsEnableUsbPnpNotify
2.ͨUSBISP豸öٵ豸صIspDevInfor豸Ϣ
  WCH55x_EnumDevices
3.Ŀļд뵽mcu flash,ָ豸
  WCH55x_FlashProgram

 
أʵֲĳںԶ
ʹò
1.WCH55x_SetIspOption
  ISP,ؽӿڣоƬͺţвǰ
  
2.WCH55x_EnumDevices
  IspOption->IspInterface = 1:طʽʱ,˺ִöٵеĴڣöٵĴصIspDevInfor豸Ϣ
  
3.WCH55x_GetIspDeviceInfor
  ǰWCH55x_GetIspDeviceInforȥȡָ豸ϢǷߣоƬUIDȡΪڲּ֧弴ãֹֻȡ
  IspDevInfor->DevIsOnline=TRUEʾѼ⵽豸ýӿ

4.Ŀļд뵽mcu flash,ָ豸
  WCH55x_FlashProgram
*/

//IspOption->IspInterface = 0:USBطʽʱ,˺ִͨUSBISP豸öٵ豸
//IspOption->IspInterface = 1:طʽʱ,˺ִöٵеĴڣöٵĴ
//ȡָ豸Ϣ
BOOL	WINAPI	WCH55x_GetIspDeviceInfor(ULONG            iIndex,      //ָ豸Ϣ
                                         PIsp55xDevInforS IspDevInfor);//豸Ϣ 
//ISPEx
BOOL	WINAPI	WCH55x_SetIspOption(CH55xIspOptionS *IspOption);//ISPѡ

//ȡISP
BOOL	WINAPI	WCH55x_GetIspOption(CH55xIspOptionS *IspOption); //ISPѡ

//USBӿдEEPROM
BOOL WCH55x_WriteDataFlash(ULONG            iIndex,            //豸
							 ULONG            StartAddr,         //ʼַ
							 ULONG            *oWriteLen,        //д볤
							 PUCHAR           DataBuf,           //ݻ
                             BOOL             bIsErase);

//USBӿڶEEPROM
BOOL WCH55x_ReadDataFlash(ULONG            iIndex,            //豸
							ULONG            StartAddr,         //ʼַ
							ULONG            *oReadLen,        //д볤
							PUCHAR           DataBuf);           //ݻ)

BOOL WINAPI WCH55xIsp_ReadConfig(ULONG DevI,
						 PUCHAR IapCfgVal, //4ֽ
						 PUCHAR IspCfgVal, //4ֽ
						 PUCHAR CFlashCfgVal, //4ֽ
						 PULONG BootVer,      
						 PUCHAR UUID);  
//ȡ
VOID WCH55x_StopOp();

//ͨUSBISP豸öٵ豸ɰBTV230ֻ֧һ豸ö
ULONG   WINAPI  WCH55x_EnumDevices(Isp55xDevInforS *IspDevInfor,  //IspDevInfor:豸Ϣ
									 UCHAR            MaxDevCnt,    //ɨ豸<=16
									 UCHAR            *BtChipSeries, //һ豸оƬϵ
									 UCHAR            *BtChipType,
									 BOOL             *IsPreBTV230);   //һ豸оƬͺ

//̼ĿļԼǰýУ飬ļʽ,WCH55x_FlashVerify
BOOL	WINAPI	WCH55x_FlashVerifyB(ULONG iIndex,        //豸
									PUCHAR UserFileDataBuf,  //ûļ
									ULONG  UserFileDataLen,  //ûļݳ
									UCHAR  UserFileDateType, //ûļʽ 0:HEXʽ,1:BINʽ
									PUCHAR IAPFileDataBuf,   //IAPļ
									ULONG  IAPFileDataLen,   //IAPļݳ
									UCHAR  IAPFileDateType);  //IAPļʽ 0:HEXʽ,1:BINʽ

//Ŀļд뵽mcu flashڣļʽ,WCH55x_FlashProgram                
BOOL	WINAPI	WCH55x_FlashProgramB(ULONG  iIndex,        //豸
									PUCHAR UserFileDataBuf,  //ûļ
									ULONG  UserFileDataLen,  //ûļݳ
									UCHAR  UserFileDateType, //ûļʽ 0:HEXʽ,1:BINʽ
									PUCHAR IAPFileDataBuf,   //IAPļ
									ULONG  IAPFileDataLen,   //IAPļݳ
									UCHAR  IAPFileDateType);  //IAPļʽ 0:HEXʽ,1:BINʽ
//ͨUSBISP豸öٵ豸ɰBTV230ֻ֧һ豸ö
ULONG   WINAPI  WCH55x_EnumDevicesEx(Isp55xDevInforS *IspDevInfor,  //IspDevInfor:豸Ϣ
									 UCHAR            MaxDevCnt,    //ɨ豸<=16
									 BOOL             *IsPreBTV230); //BTV230֮ǰ汾

//OTP
BOOL  WINAPI   WCH55x_ReadOTP(ULONG  iIndex,        //豸
							  UCHAR  OffSet,        //OTPƫֵ
							  UCHAR  *DataBuf);  //OTP

//OTPд
BOOL  WINAPI   WCH55x_WriteOTP(ULONG  iIndex,        //豸
							  UCHAR  OffSet,        //OTPƫֵ
							  UCHAR  *DataBuf);  //OTP

//ֶͽ
BOOL	WINAPI	WCH55x_IspEnd(ULONG iIndex,        //豸
							  BOOL  bIsDlReset);   //Ƿû

//CH57X
BOOL	WINAPI	WCH55x_IspSumilat(ULONG iIndex);       //豸
	   
							  
//CH32Fx
BOOL	WINAPI	WCH55x_IspRemoveProtect(ULONG iIndex);       //豸

#ifdef __cplusplus
}
#endif

#endif		// _WCH55XISP_DLL_H
